package android.app;

import android.content.ComponentName;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.ColorSpace;
import android.graphics.GraphicBuffer;
import android.graphics.Point;
import android.graphics.Rect;
import android.os.IBinder;
import android.window.WindowContainerToken;

import java.util.ArrayList;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.annotations.ShellClass;
import commons.annotations.SuperClass;
import commons.utils.Build;

@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public class ActivityManager {
    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static class TaskSnapshot {
        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public GraphicBuffer getSnapshot() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public ColorSpace getColorSpace() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public Rect getContentInsets() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public int getOrientation() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public boolean isReducedResolution() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public float getScale() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public boolean isRealSnapshot() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public boolean isTranslucent() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public int getWindowingMode() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public int getSystemUiVisibility() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.R)
        public Point getTaskSize() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.R)
        public int getRotation() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.R)
        public boolean isLowResolution() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.R)
        public long getId() {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static class TaskDescription {
        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public Bitmap getInMemoryIcon() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public int getIconResource() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public String getIconFilename() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public static Bitmap loadTaskDescriptionIcon(String iconFilename, int userId) {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public int getBackgroundColor() {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static class RecentTaskInfo {
        @Hidden(startVersion = Build.VERSION_CODES.Q)
        @SuperClass("android.app.TaskInfo")
        public ComponentName realActivity;

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        @SuperClass("android.app.TaskInfo")
        public Configuration configuration;

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        @SuperClass("android.app.TaskInfo")
        public int userId;

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        @SuperClass("android.app.TaskInfo")
        public long lastActiveTime;

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        @SuperClass("android.app.TaskInfo")
        public int displayId;

        @Hidden(startVersion = Build.VERSION_CODES.Q)
        @SuperClass("android.app.TaskInfo")
        public boolean supportsSplitScreenMultiWindow;

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public PersistedTaskSnapshotData lastSnapshotData;

        @NotInSdk
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public static class PersistedTaskSnapshotData {
            @Hidden(startVersion = Build.VERSION_CODES.S)
            public Point taskSize;

            @Hidden(startVersion = Build.VERSION_CODES.S)
            public Rect contentInsets;

            @Hidden(startVersion = Build.VERSION_CODES.S)
            public void set(PersistedTaskSnapshotData other) {
                throw new RuntimeException();
            }
        }

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        @SuperClass("android.app.TaskInfo")
        public int getWindowingMode() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.U)
        @SuperClass("android.app.TaskInfo")
        public Point positionInParent;
    }

    @ShellClass
    public static class RunningTaskInfo {
        @Hidden(startVersion = Build.VERSION_CODES.S)
        @SuperClass("android.app.TaskInfo")
        public WindowContainerToken token;

        @Hidden(startVersion = Build.VERSION_CODES.S)
        @SuperClass("android.app.TaskInfo")
        public int getActivityType() {
            throw new RuntimeException();
        }

        @SuperClass("android.app.TaskInfo")
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public ArrayList<IBinder> launchCookies;

        @SuperClass("android.app.TaskInfo")
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public PictureInPictureParams pictureInPictureParams;

        @SuperClass("android.app.TaskInfo")
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public ActivityInfo topActivityInfo;

        @SuperClass("android.app.TaskInfo")
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public Rect displayCutoutInsets;

        @SuperClass("android.app.TaskInfo")
        @Hidden(startVersion = Build.VERSION_CODES.T)
        public int topActivityType;

        @SuperClass("android.app.TaskInfo")
        @Hidden(startVersion = Build.VERSION_CODES.T)
        public int parentTaskId;

        @SuperClass("android.app.TaskInfo")
        @Hidden(startVersion = Build.VERSION_CODES.T)
        public boolean hasParentTask() {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static IActivityManager getService() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    static public boolean isHighEndGfx() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    public static int START_TASK_TO_FRONT;// = FIRST_START_SUCCESS_CODE + 2;

    @Hidden(startVersion = Build.VERSION_CODES.T)
    public static int START_SUCCESS;// = FIRST_START_SUCCESS_CODE;

    @Hidden(startVersion = Build.VERSION_CODES.T)
    public static int START_DELIVERED_TO_TOP;// = FIRST_START_SUCCESS_CODE + 3;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static boolean isStartResultSuccessful(int result) {
        throw new RuntimeException();
    }
}