package android.app;

import android.content.Context;
import android.os.Handler;
import android.os.IBinder;
import android.view.IAppTransitionAnimationSpecsFuture;
import android.view.RemoteAnimationAdapter;
import android.window.IRemoteTransition;
import android.window.RemoteTransition;

import commons.annotations.Hidden;
import commons.annotations.MethodDescriptor;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public class ActivityOptions {
    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public interface OnAnimationStartedListener {
        @Hidden(startVersion = Build.VERSION_CODES.Q)
        @MethodDescriptor(version = Build.VERSION_CODES.T, value = "(J)V")
        @MethodDescriptor(version = Build.VERSION_CODES.U, value = "(J)V")
        void onAnimationStarted();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static ActivityOptions makeMultiThumbFutureAspectScaleAnimation(Context context,
        Handler handler, IAppTransitionAnimationSpecsFuture specsFuture,
        OnAnimationStartedListener listener, boolean scaleUp) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public void setLaunchWindowingMode(int windowingMode) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public void setSplitScreenCreateMode(int splitScreenCreateMode) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static ActivityOptions makeRemoteAnimation(
            RemoteAnimationAdapter remoteAnimationAdapter) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public void setFreezeRecentTasksReordering() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static ActivityOptions makeCustomAnimation(Context context, int enterResId, int exitResId, Handler handler, OnAnimationStartedListener listener) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public void setLaunchActivityType(int activityType) {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.R)
    public interface OnAnimationFinishedListener {
        @Hidden(startVersion = Build.VERSION_CODES.R)
        @MethodDescriptor(version = Build.VERSION_CODES.U, value = "(J)V")
        void onAnimationFinished();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public static ActivityOptions makeCustomAnimation(Context context, int enterResId,
            int exitResId, Handler handler, OnAnimationStartedListener startedListener,
            OnAnimationFinishedListener finishedListener) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public static ActivityOptions makeRemoteAnimation(RemoteAnimationAdapter remoteAnimationAdapter,
            IRemoteTransition remoteTransition) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public static ActivityOptions makeRemoteTransition(IRemoteTransition remoteTransition) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public static ActivityOptions makeCustomTaskAnimation(Context context,
            int enterResId, int exitResId, Handler handler,
            OnAnimationStartedListener startedListener,
            OnAnimationFinishedListener finishedListener) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public void setSourceInfo(int type, long uptimeMillis) {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.R)
    public static class SourceInfo {
        @Hidden(startVersion = Build.VERSION_CODES.R)
        public static int TYPE_LAUNCHER = 1;

        @Hidden(startVersion = Build.VERSION_CODES.T)
        public static int TYPE_RECENTS_ANIMATION = 4;
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public ActivityOptions setTransientLaunch() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public void setSplashscreenStyle(int style) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public void setLaunchCookie(IBinder launchCookie) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public RemoteAnimationAdapter getRemoteAnimationAdapter() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public void setPendingIntentLaunchFlags(int flags) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public static ActivityOptions makeRemoteAnimation(RemoteAnimationAdapter remoteAnimationAdapter,
            RemoteTransition remoteTransition) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public static ActivityOptions makeRemoteTransition(RemoteTransition remoteTransition) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static ActivityOptions makeCustomAnimation(Context context,
        int enterResId, int exitResId, int backgroundColor, Handler handler,
        OnAnimationStartedListener startedListener,
        OnAnimationFinishedListener finishedListener) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public void setDisableStartingWindow(boolean disable) {
        throw new RuntimeException();
    }
}