package android.app;

import android.content.pm.UserInfo;
import android.os.RemoteException;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IActivityManager {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    UserInfo getCurrentUser() throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void closeSystemDialogs(String reason) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    boolean removeTask(int taskId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.T)
    default void enableBinderTracing() throws RemoteException {
        throw new RuntimeException();
    }
}