package android.app;

import android.os.RemoteException;
import android.window.TaskSnapshot;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface ITaskStackListener {
    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void onActivityDismissingDockedTask() throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void onTaskSnapshotChanged(int taskId, TaskSnapshot snapshot) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void onLockTaskModeChanged(int mode) {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    abstract class Stub implements ITaskStackListener {
    }
}