package android.content.pm;

import android.content.ComponentName;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.annotations.ShellClass;
import commons.annotations.SuperClass;
import commons.utils.Build;

@ShellClass
@SuppressWarnings("unused")
public class ActivityInfo {
    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    @Retention(RetentionPolicy.SOURCE)
    public @interface Config {}

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public static int CONFIG_ASSETS_PATHS = 0x80000000;

    @SuperClass("android.content.pm.ComponentInfo")
    @Hidden(startVersion = Build.VERSION_CODES.U)
    public ComponentName getComponentName() {
        throw new RuntimeException();
    }
}