package android.os;

import commons.annotations.Hidden;
import commons.annotations.KotlinCompile;
import commons.annotations.ShellClass;
import commons.utils.Build;

@ShellClass
@SuppressWarnings("unused")
public interface Parcelable {
    @ShellClass
    @Hidden(startVersion = Build.VERSION_CODES.S)
    interface Creator<T> {
        @KotlinCompile(startVersion = Build.VERSION_CODES.S)
        default T createFromParcel(Parcel source) {
            throw new RuntimeException();
        }

        @KotlinCompile(startVersion = Build.VERSION_CODES.S)
        default T[] newArray(int size) {
            throw new RuntimeException();
        }
    }
}