package android.provider;

import commons.annotations.Hidden;
import commons.annotations.KotlinCompile;
import commons.annotations.ShellClass;
import commons.utils.Build;

@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public class Settings {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static final class System {
        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public static String LOCK_TO_APP_ENABLED = "lock_to_app_enabled";
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static final class Global {
        @Hidden(startVersion = Build.VERSION_CODES.Q)
        public static String DEVELOPMENT_ENABLE_FREEFORM_WINDOWS_SUPPORT = "enable_freeform_support";
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public static final class Secure {
        @Hidden(startVersion = Build.VERSION_CODES.R)
        public static String USER_SETUP_COMPLETE = "user_setup_complete";

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public static String NUM_ROTATION_SUGGESTIONS_ACCEPTED =
                "num_rotation_suggestions_accepted";

        @Hidden(startVersion = Build.VERSION_CODES.T)
        public static String LAUNCHER_TASKBAR_EDUCATION_SHOWING =
                "launcher_taskbar_education_showing";

        @Hidden(startVersion = Build.VERSION_CODES.T)
        public static String NAV_BAR_KIDS_MODE = "nav_bar_kids_mode";
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public static class NameValueTable {
    }

    @ShellClass
    @KotlinCompile(startVersion = Build.VERSION_CODES.U)
    public static class SettingNotFoundException extends RuntimeException {
    }
}