package android.view;

import android.os.RemoteException;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IDockedStackListener {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onDividerVisibilityChanged(boolean visible) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onDockedStackExistsChanged(boolean exists) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onDockedStackMinimizedChanged(boolean minimized, long animDuration, boolean isHomeStackResizable) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onAdjustedForImeChanged(boolean adjustedForIme, long animDuration) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onDockSideChanged(int newDockSide) throws RemoteException;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    abstract class Stub implements IDockedStackListener {
    }
}