package android.view;

import android.content.ComponentName;
import android.content.pm.ParceledListSlice;
import android.graphics.Rect;
import android.os.RemoteException;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IPinnedStackListener {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onListenerRegistered(IPinnedStackController controller) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void onMovementBoundsChanged(Rect insetBounds, Rect normalBounds, Rect animatingBounds, boolean fromImeAdjustment, boolean fromShelfAdjustment, int displayRotation) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onImeVisibilityChanged(boolean imeVisible, int imeHeight) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void onShelfVisibilityChanged(boolean shelfVisible, int shelfHeight) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void onMinimizedStateChanged(boolean isMinimized) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onActionsChanged(ParceledListSlice actions) throws RemoteException;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    abstract class Stub implements IPinnedStackListener {
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onMovementBoundsChanged(boolean fromImeAdjustment) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onActivityHidden(ComponentName componentName) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onDisplayInfoChanged(DisplayInfo displayInfo) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onConfigurationChanged() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onAspectRatioChanged(float aspectRatio) {
        throw new RuntimeException();
    }
}