package android.view;

import android.app.ActivityManager;
import android.os.RemoteException;
import android.window.PictureInPictureSurfaceTransaction;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.annotations.MethodDescriptor;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IRecentsAnimationController {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    @MethodDescriptor(version = Build.VERSION_CODES.S, value = "(I)Landroid/window/TaskSnapshot;")
    @MethodDescriptor(version = Build.VERSION_CODES.S_V2, value = "(I)Landroid/window/TaskSnapshot;")
    @MethodDescriptor(version = Build.VERSION_CODES.T, value = "(I)Landroid/window/TaskSnapshot;")
    @MethodDescriptor(version = Build.VERSION_CODES.U, value = "(I)Landroid/window/TaskSnapshot;")
    default ActivityManager.TaskSnapshot screenshotTask(int taskId) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void setInputConsumerEnabled(boolean enabled) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void setAnimationTargetsBehindSystemBars(boolean behindSystemBars) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void setSplitScreenMinimized(boolean minimized) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void hideCurrentInputMethod() throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void finish(boolean moveHomeToTop, boolean sendUserLeaveHint) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void setCancelWithDeferredScreenshot(boolean screenshot) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void cleanupScreenshot() throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void setDeferCancelUntilNextTransition(boolean defer, boolean screenshot) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void setWillFinishToHome(boolean willFinishToHome) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default boolean removeTask(int taskId) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void setFinishTaskTransaction(int taskId, PictureInPictureSurfaceTransaction finishTransaction,
            SurfaceControl overlay) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void detachNavigationBarFromApp(boolean moveHomeToTop) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void animateNavigationBarToApp(long duration) throws RemoteException {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.U)
    class Default implements IRecentsAnimationController {
    }
}