package android.view;

import android.app.ActivityManager;
import android.graphics.Rect;
import android.os.IBinder;
import android.os.IInterface;
import android.os.RemoteException;
import android.window.TaskSnapshot;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IRecentsAnimationRunner extends IInterface {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void onAnimationCanceled(boolean deferredWithScreenshot) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void onAnimationStart(IRecentsAnimationController controller, RemoteAnimationTarget[] apps, Rect homeContentInsets, Rect minimizedHomeBounds) throws RemoteException {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    abstract class Stub implements IRecentsAnimationRunner {
        @Hidden(startVersion = Build.VERSION_CODES.U)
        public static IRecentsAnimationRunner asInterface(IBinder obj) {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onAnimationStart(IRecentsAnimationController controller,
            RemoteAnimationTarget[] apps, RemoteAnimationTarget[] wallpapers,
            Rect homeContentInsets, Rect minimizedHomeBounds) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onAnimationCanceled(ActivityManager.TaskSnapshot taskSnapshot) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onTaskAppeared(RemoteAnimationTarget app) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void onAnimationCanceled(TaskSnapshot taskSnapshot) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    default void onAnimationCanceled(int[] taskIds, TaskSnapshot[] taskSnapshots) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    default void onTasksAppeared(RemoteAnimationTarget[] app) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    @Override
    default IBinder asBinder() {
        throw new RuntimeException();
    }
}