package android.view;

import android.os.IBinder;
import android.os.IInterface;
import android.os.RemoteException;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IRemoteAnimationRunner extends IInterface {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void onAnimationStart(RemoteAnimationTarget[] apps, IRemoteAnimationFinishedCallback finishedCallback) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    default void onAnimationCancelled() throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    @Override
    default IBinder asBinder() {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    abstract class Stub implements IRemoteAnimationRunner {
        @Hidden(startVersion = Build.VERSION_CODES.U)
        public static IRemoteAnimationRunner asInterface(IBinder obj) {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.R)
    default void onAnimationStart(RemoteAnimationTarget[] apps, RemoteAnimationTarget[] wallpapers,
            final IRemoteAnimationFinishedCallback finishedCallback) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void onAnimationStart(int transit, RemoteAnimationTarget[] apps,
            RemoteAnimationTarget[] wallpapers, RemoteAnimationTarget[] nonApps,
            IRemoteAnimationFinishedCallback finishedCallback) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    default void onAnimationCancelled(boolean isKeyguardOccluded) throws RemoteException {
        throw new RuntimeException();
    }
}