package android.view;

import android.graphics.Rect;
import android.os.IBinder;
import android.os.IRemoteCallback;
import android.os.RemoteException;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IWindowManager {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void getStableInsets(int displayId, Rect outInsets) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void setNavBarVirtualKeyHapticFeedbackEnabled(boolean enabled) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void setShelfHeight(boolean visible, int shelfHeight) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void setRecentsVisibility(boolean visible) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void setPipVisibility(boolean visible) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    boolean hasNavigationBar(int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    int getNavBarPosition(int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    boolean destroyInputConsumer(String name, int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void createInputConsumer(IBinder token, String name, int displayId, InputChannel inputChannel) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    int watchRotation(IRotationWatcher watcher, int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void removeRotationWatcher(IRotationWatcher watcher) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void registerSystemGestureExclusionListener(ISystemGestureExclusionListener listener, int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void unregisterSystemGestureExclusionListener(ISystemGestureExclusionListener listener, int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void overridePendingAppTransitionMultiThumbFuture(IAppTransitionAnimationSpecsFuture specsFuture, IRemoteCallback startedCallback, boolean scaleUp, int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void overridePendingAppTransitionRemote(RemoteAnimationAdapter remoteAnimationAdapter, int displayId) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void registerDockedStackListener(IDockedStackListener listener) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void registerPinnedStackListener(int displayId, IPinnedStackListener listener) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.R)
    boolean mirrorDisplay(int displayId, SurfaceControl outSurfaceControl) throws RemoteException;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void setIgnoreOrientationRequest(int displayId, boolean ignoreOrientationRequest) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    default void clearTaskTransitionSpec() throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    default void setTaskTransitionSpec(TaskTransitionSpec spec) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    default void setRecentsAppBehindSystemBars(boolean behindSystemBars) throws RemoteException {
        throw new RuntimeException();
    }
}