package android.view;

import android.app.ActivityManager;
import android.app.WindowConfiguration;
import android.graphics.Point;
import android.graphics.Rect;
import android.os.Parcelable;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public class RemoteAnimationTarget implements Parcelable {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int MODE_OPENING = 0;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int MODE_CLOSING = 1;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public int taskId;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public int mode;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public SurfaceControl leash;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public boolean isTranslucent;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public Rect clipRect;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public Point position;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public Rect sourceContainerBounds;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public int prefixOrderIndex;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public boolean isNotInRecents;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public Rect contentInsets;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public WindowConfiguration windowConfiguration;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public SurfaceControl startLeash;

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public Rect localBounds;

    @Hidden(startVersion = Build.VERSION_CODES.R)
    public Rect screenSpaceBounds;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int MODE_CHANGING = 2;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public ActivityManager.RunningTaskInfo taskInfo;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public int windowType;

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public static Creator<RemoteAnimationTarget> CREATOR;

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public boolean allowEnterPip;

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public Rect startBounds;

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public RemoteAnimationTarget(int taskId, int mode, SurfaceControl leash, boolean isTranslucent,
            Rect clipRect, Rect contentInsets, int prefixOrderIndex, Point position,
            Rect localBounds, Rect screenSpaceBounds,
            WindowConfiguration windowConfig, boolean isNotInRecents,
            SurfaceControl startLeash, Rect startBounds,
            ActivityManager.RunningTaskInfo taskInfo, boolean allowEnterPip,
            int windowType) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    public int backgroundColor;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public void setRotationChange(int rotationChange) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public void setWillShowImeOnTarget(boolean showImeOnTarget) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public boolean hasAnimatingParent;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public boolean willShowImeOnTarget;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public int rotationChange;
}