package android.view;

import android.content.Context;
import android.graphics.Matrix;
import android.graphics.Rect;
import android.os.Bundle;
import android.view.accessibility.AccessibilityNodeInfo;

import commons.annotations.Hidden;
import commons.annotations.KotlinCompile;
import commons.annotations.NotInSdk;
import commons.annotations.ShellClass;
import commons.utils.Build;

@NotInSdk
@Hidden(startVersion = Build.VERSION_CODES.Q)
@SuppressWarnings({"unused", "ViewConstructor"})
public class View {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public ViewRootImpl getViewRootImpl() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public int[] getLocationOnScreen() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public void encode(ViewHierarchyEncoder stream) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public boolean isVisibleToUser() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    protected Context mContext;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static class AccessibilityDelegate {
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public AccessibilityNodeInfo createAccessibilityNodeInfo(View host) {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public void getBoundsOnScreen(Rect outRect) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public interface OnCreateContextMenuListener {
    }

    @ShellClass
    @KotlinCompile(startVersion = Build.VERSION_CODES.S_V2)
    public static class MeasureSpec {
    }

    @ShellClass
    @KotlinCompile(startVersion = Build.VERSION_CODES.S_V2)
    public interface OnClickListener {
    }

    @KotlinCompile(startVersion = Build.VERSION_CODES.S_V2)
    public ViewGroup.LayoutParams getLayoutParams() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public boolean isLayoutRtl() {
        throw new RuntimeException();
    }

    @KotlinCompile(startVersion = Build.VERSION_CODES.T)
    public interface OnLayoutChangeListener {
        @KotlinCompile(startVersion = Build.VERSION_CODES.T)
        void onLayoutChange(View v, int left, int top, int right, int bottom,
            int oldLeft, int oldTop, int oldRight, int oldBottom);
    }

    @KotlinCompile(startVersion = Build.VERSION_CODES.T)
    public interface OnApplyWindowInsetsListener {
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    public void setAnimationMatrix(Matrix matrix) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    public static int DRAG_FLAG_REQUEST_SURFACE_FOR_RETURN_ANIMATION = 1 << 11;

    @ShellClass
    @KotlinCompile(startVersion = Build.VERSION_CODES.U)
    public interface OnAttachStateChangeListener {
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public int mPrivateFlags;

    @ShellClass
    @KotlinCompile(startVersion = Build.VERSION_CODES.U)
    public interface OnTouchListener {
    }

    @ShellClass
    @KotlinCompile(startVersion = Build.VERSION_CODES.U)
    public interface OnLongClickListener {
    }

    @KotlinCompile(startVersion = Build.VERSION_CODES.U)
    public void setOnLongClickListener(OnLongClickListener l) {
        throw new RuntimeException();
    }

    @KotlinCompile(startVersion = Build.VERSION_CODES.U)
    public OnLongClickListener getOnLongClickListener() {
        throw new RuntimeException();
    }

    @ShellClass
    @KotlinCompile(startVersion = Build.VERSION_CODES.U)
    public interface OnFocusChangeListener {
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public boolean performAccessibilityActionInternal(int action, Bundle arguments) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public boolean requestAccessibilityFocus() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public void clearAccessibilityFocus() {
        throw new RuntimeException();
    }
}