package android.view;

import android.graphics.RecordingCanvas;
import android.graphics.Rect;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface WindowCallbacks {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onWindowSizeIsChanging(Rect newBounds, boolean fullscreen, Rect systemInsets, Rect stableInsets);

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onWindowDragResizeStart(Rect initialBounds, boolean fullscreen, Rect systemInsets, Rect stableInsets, int resizeMode);

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onWindowDragResizeEnd();

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    boolean onContentDrawn(int offsetX, int offsetY, int sizeX, int sizeY);

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onRequestDraw(boolean reportNextDraw);

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    void onPostDraw(RecordingCanvas canvas);
}