package android.view;

import android.graphics.Insets;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.util.Set;

import commons.annotations.FieldType;
import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.annotations.ShellClass;
import commons.utils.Build;

@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public class WindowManager {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static String INPUT_CONSUMER_PIP = "pip_input_consumer";

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static String INPUT_CONSUMER_RECENTS_ANIMATION = "recents_animation_input_consumer";

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_UNSET = -1;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_NONE = 0;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_ACTIVITY_OPEN = 6;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_ACTIVITY_CLOSE = 7;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_TASK_OPEN = 8;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_TASK_CLOSE = 9;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_TASK_TO_FRONT = 10;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_TASK_TO_BACK = 11;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_WALLPAPER_CLOSE = 12;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_WALLPAPER_OPEN = 13;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_WALLPAPER_INTRA_OPEN = 14;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_WALLPAPER_INTRA_CLOSE = 15;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_TASK_OPEN_BEHIND = 16;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_TASK_IN_PLACE = 17;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_ACTIVITY_RELAUNCH = 18;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_DOCK_TASK_FROM_RECENTS = 19;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_KEYGUARD_GOING_AWAY = 20;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_KEYGUARD_GOING_AWAY_ON_WALLPAPER = 21;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_KEYGUARD_OCCLUDE = 22;

    @Hidden(startVersion = Build.VERSION_CODES.Q)
    public static int TRANSIT_KEYGUARD_UNOCCLUDE = 23;

    @ShellClass
    @Hidden(startVersion = Build.VERSION_CODES.R)
    public static class LayoutParams {
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public static int INVALID_WINDOW_TYPE = -1;

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public int[] providesInsetsTypes;

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public static int TYPE_NAVIGATION_BAR;// = FIRST_SYSTEM_WINDOW + 19

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public void setSystemApplicationOverlay(boolean isSystemApplicationOverlay) {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public static int TYPE_NAVIGATION_BAR_PANEL;// = FIRST_SYSTEM_WINDOW+24;

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public int privateFlags;

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public static int SYSTEM_FLAG_SHOW_FOR_ALL_USERS = 0x00000010;

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public static int TYPE_DOCK_DIVIDER;// = FIRST_SYSTEM_WINDOW+34;

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public static int FLAG_SLIPPERY = 0x20000000;

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public static int PRIVATE_FLAG_NO_MOVE_ANIMATION = 0x00000040;

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        @FieldType(version = Build.VERSION_CODES.T, value = "[Landroid/graphics/Insets;")
        public Insets providedInternalImeInsets;

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public static int PRIVATE_FLAG_EXCLUDE_FROM_SCREEN_MAGNIFICATION = 0x00200000;

        @Hidden(startVersion = Build.VERSION_CODES.T)
        public Insets[] providedInternalInsets;

        @Hidden(startVersion = Build.VERSION_CODES.T)
        public boolean insetsRoundedCornerFrame = false;

        @Hidden(startVersion = Build.VERSION_CODES.T)
        public boolean receiveInsetsIgnoringZOrder;

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public static int TYPE_VOICE_INTERACTION;// = FIRST_SYSTEM_WINDOW+31;

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public boolean isSystemApplicationOverlay() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public InsetsFrameProvider[] providedInsets;

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public static int PRIVATE_FLAG_OPTIMIZE_MEASURE = 1 << 9;

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public CharSequence accessibilityTitle;
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_UNSET = -1;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_NONE = 0;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_ACTIVITY_OPEN = 6;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_ACTIVITY_CLOSE = 7;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_TASK_OPEN = 8;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_TASK_CLOSE = 9;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_TASK_TO_FRONT = 10;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_TASK_TO_BACK = 11;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_WALLPAPER_CLOSE = 12;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_WALLPAPER_OPEN = 13;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_WALLPAPER_INTRA_OPEN = 14;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_WALLPAPER_INTRA_CLOSE = 15;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_TASK_OPEN_BEHIND = 16;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_ACTIVITY_RELAUNCH = 18;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_KEYGUARD_GOING_AWAY = 20;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_KEYGUARD_GOING_AWAY_ON_WALLPAPER = 21;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_KEYGUARD_OCCLUDE = 22;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_OLD_KEYGUARD_UNOCCLUDE = 23;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static final int TRANSIT_CLOSE = 2;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static final int TRANSIT_OPEN = 1;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static final int TRANSIT_TO_FRONT = 3;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static final int TRANSIT_TO_BACK = 4;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int TRANSIT_CHANGE = 6;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.S)
    @Retention(RetentionPolicy.SOURCE)
    public @interface TransitionOldType {}

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    public static int TRANSIT_FLAG_KEYGUARD_GOING_AWAY = 0x100;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.U)
    @Retention(RetentionPolicy.SOURCE)
    public @interface TransitionType {}

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int TRANSIT_FLAG_KEYGUARD_LOCKED = (1 << 6); // 0x40

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int TRANSIT_SLEEP = 12;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static class ScreenshotSource {
        @Hidden(startVersion = Build.VERSION_CODES.U)
        public static int SCREENSHOT_OVERVIEW = 3;
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int TAKE_SCREENSHOT_PROVIDED_IMAGE = 3;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public Set<WindowMetrics> getPossibleMaximumWindowMetrics(int displayId) {
        throw new RuntimeException();
    }
}
