package android.window;

import android.os.IBinder;
import android.os.IInterface;
import android.os.RemoteException;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.T)
public interface IOnBackInvokedCallback extends IInterface {
    @Hidden(startVersion = Build.VERSION_CODES.T)
    default void onBackStarted() throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    default void onBackProgressed(BackEvent backEvent) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    default void onBackCancelled() throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    default void onBackInvoked() throws RemoteException {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.T)
    abstract class Stub implements IOnBackInvokedCallback {
        @Hidden(startVersion = Build.VERSION_CODES.T)
        public static IOnBackInvokedCallback asInterface(IBinder obj) {
            throw new RuntimeException();
        }

        @Override
        @Hidden(startVersion = Build.VERSION_CODES.T)
        public IBinder asBinder() {
            return null;
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    default void onBackStarted(BackMotionEvent backMotionEvent) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    default void onBackProgressed(BackMotionEvent backMotionEvent) throws RemoteException {
        throw new RuntimeException();
    }
}