package android.window;

import android.os.Binder;
import android.os.IBinder;
import android.os.IInterface;
import android.os.RemoteException;
import android.view.SurfaceControl;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.S)
public interface IRemoteTransition extends IInterface {
    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void startAnimation(IBinder token, TransitionInfo info, SurfaceControl.Transaction t,
        IRemoteTransitionFinishedCallback finishCallback) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void mergeAnimation(IBinder transition, TransitionInfo info, SurfaceControl.Transaction t,
        IBinder mergeTarget, IRemoteTransitionFinishedCallback finishCallback) throws RemoteException {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.S)
    abstract class Stub extends Binder implements IRemoteTransition {
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public static IRemoteTransition asInterface(IBinder obj) {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public IBinder asBinder() {
            throw new RuntimeException();
        }
    }
}