package android.window;

import android.os.RemoteException;
import android.view.SurfaceControl;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.S)
public interface IRemoteTransitionFinishedCallback {
    @Hidden(startVersion = Build.VERSION_CODES.S)
    default void onTransitionFinished(WindowContainerTransaction wct) throws RemoteException {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S_V2)
    default void onTransitionFinished(WindowContainerTransaction wct, SurfaceControl.Transaction sct) throws RemoteException {
        throw new RuntimeException();
    }
}