package android.window;

import android.app.ActivityManager;
import android.graphics.Point;
import android.graphics.Rect;
import android.view.SurfaceControl;

import java.util.List;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.S)
public class TransitionInfo {
    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int FLAG_IS_WALLPAPER = 1 << 1;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int FLAG_TRANSLUCENT = 4;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int FLAG_SHOW_WALLPAPER = 1;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static int FLAG_STARTING_WINDOW_TRANSFER_RECIPIENT = 1 << 3;

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public List<Change> getChanges() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public Change getChange(WindowContainerToken token) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public SurfaceControl getRootLeash() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public int getType() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public Point getRootOffset() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static boolean isIndependent(Change change, TransitionInfo info) {
        throw new RuntimeException();
    }

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.S)
    public static final class Change {
        @Hidden(startVersion = Build.VERSION_CODES.S)
        public ActivityManager.RunningTaskInfo getTaskInfo() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public int getMode() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public int getFlags() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public WindowContainerToken getParent() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public int getEndRotation() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public int getStartRotation() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public Rect getEndAbsBounds() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public SurfaceControl getLeash() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public WindowContainerToken getContainer() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public Point getEndRelOffset() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S)
        public Rect getStartAbsBounds() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.S_V2)
        public boolean getAllowEnterPip() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.T)
        public int getBackgroundColor() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public boolean hasFlags(int flags) {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public WindowContainerToken getLastParent() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public int getEndDisplayId() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public int getStartDisplayId() {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int FLAG_FIRST_CUSTOM = 1 << 22;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static final class Root {
        @Hidden(startVersion = Build.VERSION_CODES.U)
        public SurfaceControl getLeash() {
            throw new RuntimeException();
        }

        @Hidden(startVersion = Build.VERSION_CODES.U)
        public Point getOffset() {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public Root getRoot(int idx) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int FLAG_IN_TASK_WITH_EMBEDDED_ACTIVITY = 1 << 9;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int FLAG_IS_DISPLAY = 1 << 5;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int FLAG_MOVED_TO_TOP = 1 << 20;

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public static int FLAG_WILL_IME_SHOWN = 1 << 11;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.U)
    public @interface TransitionMode {
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public int findRootIndex(int displayId) {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public void releaseAllSurfaces() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public int getFlags() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    public void releaseAnimSurfaces() {
        throw new RuntimeException();
    }

    @Hidden(startVersion = Build.VERSION_CODES.T)
    public static int FLAG_FILLS_TASK = 1 << 10;
}