package com.android.internal.app;

import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@SuppressWarnings("unused")
@Hidden(startVersion = Build.VERSION_CODES.Q)
public interface IVoiceInteractionManagerService {
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    boolean showSessionFromSession(IBinder token, Bundle sessionArgs, int flags) throws RemoteException;

    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.Q)
    abstract class Stub implements IVoiceInteractionManagerService {
        public static IVoiceInteractionManagerService asInterface(IBinder obj) {
            throw new RuntimeException();
        }
    }

    @Hidden(startVersion = Build.VERSION_CODES.U)
    default boolean showSessionFromSession(IBinder token, Bundle sessionArgs, int flags,
        String attributionTag) throws RemoteException {
        throw new RuntimeException();
    }
}