package com.android.internal.util;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import commons.annotations.Hidden;
import commons.annotations.NotInSdk;
import commons.utils.Build;

@NotInSdk
@Hidden(startVersion = Build.VERSION_CODES.S)
@Retention(RetentionPolicy.SOURCE)
@Target({ElementType.TYPE})
public @interface DataClass {
    @NotInSdk
    @Hidden(startVersion = Build.VERSION_CODES.S)
    @Retention(RetentionPolicy.SOURCE)
    @Target({ElementType.METHOD})
    @interface Generated {
        @Hidden(startVersion = Build.VERSION_CODES.S)
        long time();

        @Hidden(startVersion = Build.VERSION_CODES.S)
        String codegenVersion();

        @Hidden(startVersion = Build.VERSION_CODES.S)
        String sourceFile();

        @Hidden(startVersion = Build.VERSION_CODES.S)
        String inputSignatures() default "";

        @NotInSdk
        @Hidden(startVersion = Build.VERSION_CODES.S)
        @Retention(RetentionPolicy.SOURCE)
        @Target({ElementType.FIELD, ElementType.METHOD, ElementType.ANNOTATION_TYPE, ElementType.CONSTRUCTOR, ElementType.TYPE})
        @interface Member {
        }
    }
}