package commons.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Repeatable;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 定义字段类型
 */
@Target(ElementType.FIELD)
@Retention(RetentionPolicy.RUNTIME)
@Repeatable(FieldType.FieldTypes.class)
public @interface FieldType {
    /**
     * 开始使用的版本
     *
     * @return 开始使用的版本
     */
    int version();

    /**
     * 字段类型
     *
     * @return 字段类型
     */
    String value();

    @Target(ElementType.FIELD)
    @Retention(RetentionPolicy.RUNTIME)
    @interface FieldTypes {
        FieldType[] value();
    }
}