package commons.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Repeatable;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 定义方法描述符
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
@Repeatable(MethodDescriptor.MethodDescriptors.class)
public @interface MethodDescriptor {
    /**
     * 使用的版本
     *
     * @return 使用的版本
     */
    int version();

    /**
     * 方法描述符
     *
     * @return 方法描述符
     */
    String value();

    @Target(ElementType.METHOD)
    @Retention(RetentionPolicy.RUNTIME)
    @interface MethodDescriptors {
        MethodDescriptor[] value();
    }
}